package org.rapidoid.demo.http;

/*
 * #%L
 * rapidoid-demo
 * %%
 * Copyright (C) 2014 Nikolche Mihajlovski
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import java.util.concurrent.atomic.AtomicLong;

import org.rapidoid.util.U;

import com.rapidoid.http.Handler;
import com.rapidoid.http.Web;
import com.rapidoid.http.WebExchange;

public class HttpDemo {

	public static void main(String[] args) {
		U.args(args);

		final AtomicLong nn = new AtomicLong();

		Web.get("/user", new Handler() {
			@Override
			public void handle(WebExchange x) {
				x.write("Hi: " + nn.incrementAndGet());
				x.done();
			}
		});

		Web.start();
	}

}
